_ = require('../../node_modules/knex/node_modules/lodash/lodash.js')
fs = require('fs')

knex = require('knex')({
    client: 'sqlite3'
    connection: 
        filename: './bookshelf/bin/sample.db'
    debug:true
})

class DB
    createTables: ->
        #books
        knex.schema.hasTable('books')
            .then (exists)->
                if !exists
                    knex.schema.createTable 'books', (table)->
                        table.increments('id').primary()
                        table.string 'name'
        #summaries
            .then ->
                knex.schema.hasTable('summaries')
            .then (exists)->
                if !exists
                    knex.schema.createTable 'summaries', (table)->
                        table.increments('id').primary()
                        table.string 'details'
                        table.integer('book_id').unique().references('books.id')

    insertDatas: ->
        bookdataText = fs.readFileSync './bookshelf/bin/bookdata.json', {encoding:'utf8'}
        bookdata = JSON.parse bookdataText

        _.each bookdata, (book, index)->

            knex('books').insert {
                name: book.title
            }
            .then (ids)->
                knex('summaries').insert {
                    book_id: ids[0]
                    details: book.summary
                }

    find1: ->
        knex.select().from('books')
            .then (rows) ->
                console.log 'find1 --'
                _.each rows, (row)->
                    console.log row

    find2: ->
        knex.select('id', 'details').from('summaries').where 'details', 'like', '%世界%'
            .then (rows) ->
                console.log 'find2 --'
                _.each rows, (row)->
                    console.log row

    find3: ->
        knex.select().from('books').leftJoin('summaries', 'books.id', 'summaries.book_id')
            .limit(3).offset(2)
            .then (rows) ->
                console.log 'find3 --'
                _.each rows, (row)->
                    console.log row

module.exports = DB
